# class OpenSSL::X509::Request

### Public Class Methods

new (p1 = v1)
Source

    static VALUE
    ossl_x509req_initialize(int argc, VALUE *argv, VALUE self)
    {
        BIO *in;
        X509_REQ *req, *req_orig = RTYPEDDATA_DATA(self);
        VALUE arg;

        rb_check_frozen(self);
        if (rb_scan_args(argc, argv, "01", &arg) == 0) {
            return self;
        }
        arg = ossl_to_der_if_possible(arg);
        in = ossl_obj2bio(&arg);
        req = d2i_X509_REQ_bio(in, NULL);
        if (!req) {
            OSSL_BIO_reset(in);
            req = PEM_read_bio_X509_REQ(in, NULL, NULL, NULL);
        }
        BIO_free(in);
        if (!req)
            ossl_raise(eX509ReqError, "PEM_read_bio_X509_REQ");

        RTYPEDDATA_DATA(self) = req;
        X509_REQ_free(req_orig);

        return self;
    }

### Public Instance Methods

== (other)
Source

    # File ext/openssl/lib/openssl/x509.rb, line 385
    def ==(other)
      return false unless Request === other
      to_der == other.to_der
    end

add_attribute (p1)
Source

    static VALUE
    ossl_x509req_add_attribute(VALUE self, VALUE attr)
    {
        X509_REQ *req;

        GetX509Req(self, req);
        if (!X509_REQ_add1_attr(req, GetX509AttrPtr(attr))) {
            ossl_raise(eX509ReqError, NULL);
        }

        return attr;
    }

attributes ()
Source

    static VALUE
    ossl_x509req_get_attributes(VALUE self)
    {
        X509_REQ *req;
        int count, i;
        X509_ATTRIBUTE *attr;
        VALUE ary;

        GetX509Req(self, req);

        count = X509_REQ_get_attr_count(req);
        if (count < 0) {
            OSSL_Debug("count < 0???");
            return rb_ary_new();
        }
        ary = rb_ary_new2(count);
        for (i=0; i<count; i++) {
            attr = X509_REQ_get_attr(req, i);
            rb_ary_push(ary, ossl_x509attr_new(attr));
        }

        return ary;
    }

attributes= (p1)
Source

    static VALUE
    ossl_x509req_set_attributes(VALUE self, VALUE ary)
    {
        X509_REQ *req;
        X509_ATTRIBUTE *attr;
        long i;
        VALUE item;

        Check_Type(ary, T_ARRAY);
        for (i=0;i<RARRAY_LEN(ary); i++) {
            OSSL_Check_Kind(RARRAY_AREF(ary, i), cX509Attr);
        }
        GetX509Req(self, req);
        for (i = X509_REQ_get_attr_count(req); i > 0; i--)
            X509_ATTRIBUTE_free(X509_REQ_delete_attr(req, 0));
        for (i=0;i<RARRAY_LEN(ary); i++) {
            item = RARRAY_AREF(ary, i);
            attr = GetX509AttrPtr(item);
            if (!X509_REQ_add1_attr(req, attr)) {
                ossl_raise(eX509ReqError, "X509_REQ_add1_attr");
            }
        }
        return ary;
    }

initialize_copy (p1)
Source

    static VALUE
    ossl_x509req_copy(VALUE self, VALUE other)
    {
        X509_REQ *a, *b, *req;

        rb_check_frozen(self);
        if (self == other) return self;
        GetX509Req(self, a);
        GetX509Req(other, b);
        if (!(req = X509_REQ_dup(b))) {
            ossl_raise(eX509ReqError, NULL);
        }
        X509_REQ_free(a);
        DATA_PTR(self) = req;

        return self;
    }

public_key ()
Source

    static VALUE
    ossl_x509req_get_public_key(VALUE self)
    {
        X509_REQ *req;
        EVP_PKEY *pkey;

        GetX509Req(self, req);
        if (!(pkey = X509_REQ_get_pubkey(req))) { /* adds reference */
            ossl_raise(eX509ReqError, NULL);
        }

        return ossl_pkey_new(pkey); /* NO DUP - OK */
    }

public_key= (p1)
Source

    static VALUE
    ossl_x509req_set_public_key(VALUE self, VALUE key)
    {
        X509_REQ *req;
        EVP_PKEY *pkey;

        GetX509Req(self, req);
        pkey = GetPKeyPtr(key);
        ossl_pkey_check_public_key(pkey);
        if (!X509_REQ_set_pubkey(req, pkey))
            ossl_raise(eX509ReqError, "X509_REQ_set_pubkey");
        return key;
    }

sign (p1, p2)
Source

    static VALUE
    ossl_x509req_sign(VALUE self, VALUE key, VALUE digest)
    {
        X509_REQ *req;
        EVP_PKEY *pkey;
        const EVP_MD *md;

        GetX509Req(self, req);
        pkey = GetPrivPKeyPtr(key); /* NO NEED TO DUP */
        if (NIL_P(digest)) {
            md = NULL; /* needed for some key types, e.g. Ed25519 */
        } else {
            md = ossl_evp_get_digestbyname(digest);
        }
        if (!X509_REQ_sign(req, pkey, md)) {
            ossl_raise(eX509ReqError, NULL);
        }

        return self;
    }

signature_algorithm ()
Source

    static VALUE
    ossl_x509req_get_signature_algorithm(VALUE self)
    {
        X509_REQ *req;
        const X509_ALGOR *alg;
        BIO *out;

        GetX509Req(self, req);

        if (!(out = BIO_new(BIO_s_mem()))) {
            ossl_raise(eX509ReqError, NULL);
        }
        X509_REQ_get0_signature(req, NULL, &alg);
        if (!i2a_ASN1_OBJECT(out, alg->algorithm)) {
            BIO_free(out);
            ossl_raise(eX509ReqError, NULL);
        }

        return ossl_membio2str(out);
    }

subject ()
Source

    static VALUE
    ossl_x509req_get_subject(VALUE self)
    {
        X509_REQ *req;
        X509_NAME *name;

        GetX509Req(self, req);
        if (!(name = X509_REQ_get_subject_name(req))) { /* NO DUP - don't free */
            ossl_raise(eX509ReqError, NULL);
        }

        return ossl_x509name_new(name);
    }

subject= (p1)
Source

    static VALUE
    ossl_x509req_set_subject(VALUE self, VALUE subject)
    {
        X509_REQ *req;

        GetX509Req(self, req);
        /* DUPs name */
        if (!X509_REQ_set_subject_name(req, GetX509NamePtr(subject))) {
            ossl_raise(eX509ReqError, NULL);
        }

        return subject;
    }

to_der ()
Source

    static VALUE
    ossl_x509req_to_der(VALUE self)
    {
        X509_REQ *req;
        VALUE str;
        long len;
        unsigned char *p;

        GetX509Req(self, req);
        if ((len = i2d_X509_REQ(req, NULL)) <= 0)
            ossl_raise(eX509ReqError, NULL);
        str = rb_str_new(0, len);
        p = (unsigned char *)RSTRING_PTR(str);
        if (i2d_X509_REQ(req, &p) <= 0)
            ossl_raise(eX509ReqError, NULL);
        ossl_str_adjust(str, p);

        return str;
    }

to_pem ()
Source

    static VALUE
    ossl_x509req_to_pem(VALUE self)
    {
        X509_REQ *req;
        BIO *out;

        GetX509Req(self, req);
        if (!(out = BIO_new(BIO_s_mem()))) {
            ossl_raise(eX509ReqError, NULL);
        }
        if (!PEM_write_bio_X509_REQ(out, req)) {
            BIO_free(out);
            ossl_raise(eX509ReqError, NULL);
        }

        return ossl_membio2str(out);
    }

Also aliased as: to_s
to_s ()
Alias for: to_pem
to_text ()
Source

    static VALUE
    ossl_x509req_to_text(VALUE self)
    {
        X509_REQ *req;
        BIO *out;

        GetX509Req(self, req);
        if (!(out = BIO_new(BIO_s_mem()))) {
            ossl_raise(eX509ReqError, NULL);
        }
        if (!X509_REQ_print(out, req)) {
            BIO_free(out);
            ossl_raise(eX509ReqError, NULL);
        }

        return ossl_membio2str(out);
    }

verify (p1)
Source

    static VALUE
    ossl_x509req_verify(VALUE self, VALUE key)
    {
        X509_REQ *req;
        EVP_PKEY *pkey;

        GetX509Req(self, req);
        pkey = GetPKeyPtr(key);
        ossl_pkey_check_public_key(pkey);
        switch (X509_REQ_verify(req, pkey)) {
          case 1:
            return Qtrue;
          case 0:
            ossl_clear_error();
            return Qfalse;
          default:
            ossl_raise(eX509ReqError, NULL);
        }
    }

Checks that cert signature is made with PRIVversion of this PUBLIC ‘key’

version ()
Source

    endif

    static VALUE
    ossl_x509req_get_version(VALUE self)
    {
        X509_REQ *req;
        long version;

        GetX509Req(self, req);
        version = X509_REQ_get_version(req);

        return LONG2NUM(version);
    }

version= (p1)
Source

    static VALUE
    ossl_x509req_set_version(VALUE self, VALUE version)
    {
        X509_REQ *req;
        long ver;

        if ((ver = NUM2LONG(version)) < 0) {
            ossl_raise(eX509ReqError, "version must be >= 0!");
        }
        GetX509Req(self, req);
        if (!X509_REQ_set_version(req, ver)) {
            ossl_raise(eX509ReqError, "X509_REQ_set_version");
        }

        return version;
    }